# This package does not have anything to compile and have debug symbols
%global debug_package %{nil}

Name:           asahi-platform-metapackage
Version:        0
Release:        1%{?dist}
Summary:        Metapackage declaring Asahi platform dependencies
Group:          Metapackages
License:        MIT
URL:            https://gitlab.com/CentOS/Hyperscale/rpms/asahi-platform-metapackage
ExclusiveArch:  aarch64

BuildRequires:  systemd-rpm-macros
Requires:       %{name}-core = %{version}-%{release}
Requires:       (%{name}-audio = %{version}-%{release} if pipewire)
Requires:       (%{name}-plasma = %{version}-%{release} if plasma-desktop)
%dnl If/when we have desktop subpackages or whatever, we can make them
%dnl conditional dependencies with the following format:
%dnl Requires:       (%{name}-desktop-<variant> = %{version}-%{release} if <desktop-main-package>)
Requires:       (%{name}-desktop = %{version}-%{release} if centos-stream-spin-hyperscale-release)

%description
This is a simple RPM package that defines the Asahi platform
software dependencies.

%files
%{_sysconfdir}/dnf/protected.d/%{name}.conf

%dnl -------------------------------------------------------------------

%package core
Summary:        Metapackage declaring core Asahi platform dependencies
Requires:       alsa-ucm-asahi
Requires:       asahi-fwupdate
Requires:       dracut-asahi
Requires:       kernel-16k
Requires:       kernel-16k-modules-extra
Requires:       update-m1n1
# https://bugzilla.redhat.com/show_bug.cgi?id=2367248
# Requires:       tiny-dfr
Requires:       (widevine-installer if (chromium or firefox))
%dnl Block the 4k kernel
Conflicts:      kernel-core
Conflicts:      kernel-devel
Conflicts:      kernel-debug-core
Conflicts:      kernel-debug-devel
%dnl Block the 64k kernel
Conflicts:      kernel-64k-core
Conflicts:      kernel-64k-devel
Conflicts:      kernel-64k-debug-core
Conflicts:      kernel-64k-debug-devel
%dnl Block the rt kernel
Conflicts:      kernel-rt-core
Conflicts:      kernel-rt-devel
Conflicts:      kernel-rt-debug-core
Conflicts:      kernel-rt-debug-devel
%dnl Block the rt 64k kernel
Conflicts:      kernel-rt-64k-core
Conflicts:      kernel-rt-64k-devel
Conflicts:      kernel-rt-64k-debug-core
Conflicts:      kernel-rt-64k-debug-devel

%description core
This package declares the core dependencies for the Asahi platform.

%files core
%dnl No files to ship

%dnl -------------------------------------------------------------------

%package audio
Summary:        Metapackage declaring audio support Asahi platform dependencies
Requires:       asahi-audio >= 0.5-1
Requires:       speakersafetyd >= 0.1.4-1
Conflicts:      pulseaudio

%description audio
This package declares the audio dependencies for the Asahi platform.

%files audio
%dnl No files to ship

%dnl -------------------------------------------------------------------

%package plasma
Summary:        Metapackage declaring Plasma desktop support Asahi platform dependencies
%dnl No deps at this time, just a temporary KWin workaround

%description plasma
This package declares the KDE Plasma dependencies for the Asahi platform.

%files plasma
%{_sysconfdir}/xdg/kcminputrc

%package desktop
Summary:        Metapackage declaring package recommendations for Asahi desktop systems
Requires:       sed
Requires:       grub2-tools-minimal
Requires:       grub2-tools
Recommends:     asahi-battery
Recommends:     mesa-libOpenCL

%description desktop
This package declares recommeded packages for Desktop Environment Asahi platform installations.
This contains the OpenCL runtime and persistant battery charge control support using systemd.

%files desktop
%if (0%{?rhel} && 0%{?rhel} < 11)
%{_environmentdir}/50-asahi-gtk-ngl.conf
%endif

%dnl -------------------------------------------------------------------

%prep
%dnl Nothing to do

%build
%dnl Nothing to do

%install
# Install DNF protected package snippet to prevent it from being accidentally uninstalled
mkdir -p %{buildroot}%{_sysconfdir}/dnf/protected.d
echo "%{name}" > %{buildroot}%{_sysconfdir}/dnf/protected.d/%{name}.conf

# Workaround for gtk4 bug:
# https://gitlab.gnome.org/GNOME/gtk/-/issues/7229
# fixed in gtk4 4.18 available in Fedora 42
%if (0%{?rhel} && 0%{?rhel} < 11)
mkdir -p %{buildroot}%{_environmentdir}
echo 'GSK_RENDERER=ngl' > %{buildroot}%{_environmentdir}/50-asahi-gtk-ngl.conf
%endif

# Disable Tap-to-Click by default since it's the less confusing default (force click is always enabled)
mkdir -p %{buildroot}%{_sysconfdir}/xdg
cat > %{buildroot}%{_sysconfdir}/xdg/kcminputrc <<EOF
[Libinput][Defaults]
TapToClick=false
EOF

%changelog
* Mon May 19 2025 Davide Cavalca <dcavalca@centosproject.org> - 0-1
- Initial package
